/*****************************************************************
 *      jogadorEspecialista.c
 * Interage com o usurio para jogar jogo da velha.
 * Bot utiliza sistema especialista (baseado em regras) como algoritmo de IA.
 ******************************************************************
 * Autor: Luciano Antonio Digiampietri
 * Data : 03/07/2008 
 *****************************************************************/

#include "jogoDaVelhaEspecialista.c"

void jogadaAutomatica(JOGO * j, jogador * jog){
	printf("Sistema especialista - ");
	int fimEstimado = 0;
	JOGADA_VALOR res = jogadaDoEspecialista(*j);
    printf("jogada recomenda: %d [valor %d]\n",res.j,res.v);
	int pos = res.j;
	if (inserirJogada(j,pos,*jog)) {
		printf("Jogada realizada com sucesso.\n");
		*jog=outroJogador(*jog);
	}
	else printf("Nao foi possivel realizar a jogada na posicao %d.\n",pos);	
}

void jogar(JOGO * j, jogador * jog){
	int pos;
	scanf("%d",&pos);
	if (inserirJogada(j,pos,*jog)) {
		printf("Jogada realizada com sucesso.\n");
		*jog=outroJogador(*jog);
	}
	else printf("Nao foi possivel realizar a jogada na posicao %d.\n",pos);
}

void inicializar(JOGO * j, jogador jogAtual){
	inicializarJogo(j,jogAtual);
}

void help(){
  printf("Comandos validos: \n");
  printf("   b : jogada do especialista (jogada automatica)\n");
  printf("   j <posicao[0..8]> : jogar na posicao\n");
  printf("   h : exibir esta mensagem de ajuda\n");
  printf("   r : re-iniciar jogo\n");
  printf("   q : encerrar programa\n");
}

int main(){
  JOGO jogo;
  jogador jogadorAtual = j1;
  inicializarJogo(&jogo,j1);
  help();
  char comando = ' ';
  scanf("%c",&comando);
  while (comando != 'q'){
    switch (comando) {
      case 'r' : inicializar(&jogo,jogadorAtual); break;
      case 'j' : jogar(&jogo, &jogadorAtual); break;
      case 'h' : help(); break;
      case 'b' : jogadaAutomatica(&jogo, &jogadorAtual); break;
      default: {while (comando != '\n') scanf("%c",&comando);meuLog(jogo);};
    } 
    scanf("%c",&comando);
  }


  return 0;
  
}

