/*****************************************************************
 *      jogadorMiniMax.c
 * Interage com o usurio para jogar jogo da velha.
 * Bot utiliza busca miniMax (ou max min) como algoritmo de IA.
 ******************************************************************
 * Autor: Luciano Antonio Digiampietri
 * Data : 29/06/2008 
 *****************************************************************/

#include "jogoDaVelhaMiniMax.c"

void buscaMM(JOGO * j, jogador * jog){
	printf("Busca Max Min - ");
	int fimEstimado = 0;
	JOGADA_VALOR res = buscaMaxMin(*j,min,0);
	if (res.v != 0) fimEstimado = 9-abs(res.v);
	if (res.v==0) printf("melhor jogada: %d [empate estimado]\n",res.j);
	else if(res.v<0) {
         if (fimEstimado==0) printf("melhor jogada: %d [jogador atual ganhou]\n",res.j);
         else printf("melhor jogada: %d [jogador atual ganhara em %d jogada(s)]\n",res.j,fimEstimado);
      }
	  else if (fimEstimado==0) printf("resultado: jog: %d [jogador atual perdeu]\n",res.j);
       	 else printf("resultado: jog: %d [jogador atual perdera em %d jogada(s)]\n",res.j,fimEstimado);
	int pos = res.j;
	if (inserirJogada(j,pos,*jog)) {
		printf("Jogada realizada com sucesso.\n");
		*jog=outroJogador(*jog);
	}
	else printf("Nao foi possivel realizar a jogada na posicao %d.\n",pos);	
}

void jogar(JOGO * j, jogador * jog){
	int pos;
	scanf("%d",&pos);
	if (inserirJogada(j,pos,*jog)) {
		printf("Jogada realizada com sucesso.\n");
		*jog=outroJogador(*jog);
	}
	else printf("Nao foi possivel realizar a jogada na posicao %d.\n",pos);
}

void inicializar(JOGO * j, jogador jogAtual){
	inicializarJogo(j,jogAtual);
}

void help(){
  printf("Comandos validos: \n");
  printf("   b : buscaMaxMin (jogada automatica)\n");
  printf("   j <posicao[0..8]> : jogar na posicao\n");
  printf("   h : exibir esta mensagem de ajuda\n");
  printf("   r : re-iniciar jogo\n");
  printf("   q : encerrar programa\n");
}

int main(){
  JOGO jogo;
  jogador jogadorAtual = j1;
  inicializarJogo(&jogo,j1);
  help();
  char comando = ' ';
  scanf("%c",&comando);
  while (comando != 'q'){
    switch (comando) {
      case 'r' : inicializar(&jogo,jogadorAtual); break;
      case 'j' : jogar(&jogo, &jogadorAtual); break;
      case 'h' : help(); break;
      case 'b' : buscaMM(&jogo, &jogadorAtual); break;
      default: {while (comando != '\n') scanf("%c",&comando);meuLog(jogo);};
    } 
    scanf("%c",&comando);
  }


  return 0;
  
}

