/*****************************************************************
 *      jogoDaVelhaMiniMax.c
 * Possui toda a logica, estruturas e IA para um jogo da velha.
 * Bot utiliza busca maxMin como algoritmo de IA.
 ******************************************************************
 * Autor: Luciano Antonio Digiampietri
 * Data : 29/06/2008 
 *****************************************************************/

# include "jogoDaVelhaUtil.c"

typedef enum{max,min} opcao; // opcao da buscaMaxMin (se estah maximizando ou minimizando)

/* minMax: se opcao = min retorna o minimo entre 'a' e 'b', caso contrario retorna o
   maximo entre 'a' e 'b' */
int minMax(int a, int b, opcao op){
	if ((op==min && a<b) || (op==max && a>b)) return a;
	return b;
} /* minMax */

/* retorna max caso a opcao de entra seja min e min caso contrario */
opcao outraOpcao(opcao op){
	if (op==max) return min;
	return max;
}


/* busca max min (IA) para se selecionar a jogada atual do bot, minimizando
 * a melhor jogada do adversario.                                           */
JOGADA_VALOR buscaMaxMin(JOGO j, opcao op, int nivelAtual){
	nivelAtual++;
	LISTA_DE_JOGADAS jogadas = listaDeJogadas(&j); // posicao 0 guarda o numero de jogadas validas
	int valores[10];
	int jogadasValidas = jogadas.jogadas[0];
	int i;
	valores[0] = jogadasValidas;
	
	for (i=1;i<=jogadasValidas;i++){
		if (op == min){
		  valores[i] = 99999999;
		}else{
		  valores[i] = -99999999;
		}
	}
	for (i=1;i<=jogadasValidas;i++){
		JOGADA jogadaAtual = jogadas.jogadas[i];
		JOGO temp = j;
		jogador jogadorAtual = temp.jogadorAtual;
		inserirJogada(&temp,jogadaAtual,jogadorAtual);
		jogador vitorioso;
		bool fim = fimDeJogo(temp,&vitorioso);
		if (fim){
			if (vitorioso == empate){
				valores[i] = minMax(valores[i],0,op);
			}else {
				if (op==min) valores[i] = minMax(valores[i],-10+nivelAtual,min);
				else valores[i] = minMax(valores[i],10-nivelAtual,max);
			}
		}else{
			JOGADA_VALOR jv = buscaMaxMin(temp,outraOpcao(op),nivelAtual);
			valores[i] = minMax(valores[i],jv.v,op);
		}
	}
	int jogadaSel = 1;
	int valorSel = valores[1];
	if (op==min){
		for (i=2;i<=jogadasValidas;i++){
			if (valores[i]<valorSel){
				jogadaSel=i;
				valorSel=valores[i];
			}
		}
	}else{
		for (i=2;i<=jogadasValidas;i++){
			if (valores[i]>valorSel){
				jogadaSel=i;
				valorSel=valores[i];
			}
		}
	}
	JOGADA_VALOR res;
	res.j = jogadas.jogadas[jogadaSel];
	res.v = valorSel;
	// LOG sobre o resultado da busca
	//if (nivelAtual<3) printf("Selecionada [nivel/jogada/#jogadas %d/%d/%d]: %d %d\n",nivelAtual, res.j,jogadasValidas,res.j,res.v);
	return res;
}


